<template>
  <component
    :is="tag || 'div'"
    :class="{ 'ToggleButton--HasChanged': hasChanged }"
    class="ToggleButton"
  >
    <label v-if="label" :for="uuid + '__input'" class="ToggleButton__Label">
      {{ label }}
    </label>

    <!--suppress HtmlFormInputWithoutLabel -->
    <input
      :id="uuid + '__input'"
      v-model="value"
      class="ToggleButton__Control"
      type="checkbox"
    />
  </component>
</template>

<script lang="ts">
import { defineComponent } from 'vue'
import Button from '@/components/Button.vue'
import { isControl, ControlEmits } from '@/components/controls/mixins/IsControl'

export default defineComponent({
  name: 'ToggleButton',
  components: { Button },
  emits: [...ControlEmits],
  props: {
    tag: String,
    label: String,
    modelValue: Boolean,
    restoreValue: null,
    noTranslate: Boolean,
    debounceDelay: Number,
  },

  setup(props, context) {
    return {
      ...isControl<boolean>({ props, context }),
    }
  },
})
</script>

<style lang="scss" scoped>
@use '../../style/variables' as v;
@use './mixins/control' as c;

.ToggleButton {
  $root: &;
  $circleSize: 24px;
  $spacing: 2px;
  $moreWidth: 15px;
  $width: ($circleSize + $spacing) * 2 + $moreWidth;

  @include c.control;

  display: inline-flex;
  align-items: center;
  width: 100%;
  padding: 0;
  border: none;

  &__Label {
    flex: 1 1;
    order: 2;
    margin: v.$spacing;
    cursor: pointer;
  }

  &__Control {
    position: relative;
    display: inline-block;
    order: 3;
    overflow: hidden;
    width: $width;
    height: $circleSize + ($spacing * 2);
    margin: 0 $circleSize;
    border: none;
    border-radius: $circleSize / 2 + $spacing;
    background-color: var(--danger);
    outline: none;
    cursor: pointer;
    transition: background-color ease 0.3s;
    appearance: none;

    &::before {
      content: 'on off';
      position: absolute;
      top: $spacing;
      left: $spacing;
      z-index: 2;
      display: block;
      width: $circleSize;
      height: $circleSize;
      border-radius: 50%;
      background: #fff;
      color: #fff;
      box-shadow: 0 1px 2px rgba(0, 0, 0, 0.2);
      font-weight: bold;
      font-size: $circleSize / 2;
      line-height: $circleSize;
      text-indent: -$moreWidth/2 - $circleSize;
      text-transform: uppercase;
      white-space: nowrap;
      word-spacing: $circleSize + $moreWidth;
      transition: all cubic-bezier(0.3, 1, 0.7, 1) 0.3s;
    }

    &:checked {
      background-color: var(--success);
    }

    &:checked::before {
      left: $width - $spacing - $circleSize;
    }
  }

  &__Restore {
    margin-left: v.$spacing;
  }

  &--reverseOrder {
    #{$root}__Control {
      order: 1;
    }
  }
}
</style>
